//+------------------------------------------------------------------+
//|                                                Test Strategy.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <CustomFunction.mqh>

int ticket;
int slippage = 0;
int MagicNumber = 1;
extern int Stoploss = 200;
extern int Take_profit = 200;
int Risk_Per_Trade = 2;

//+------------------------------------------------------------------+
//|                           INDICATOR                              |
//+------------------------------------------------------------------+
double upSignal(int shift=0)
  {
   return iCustom(Symbol(),PERIOD_CURRENT,"price-channel-signal-alerts-indicator",8,3,true,PRICE_CLOSE,false,0,shift);
  }
//
double downSignal(int shift=0)
  {
   return iCustom(Symbol(),PERIOD_CURRENT,"price-channel-signal-alerts-indicator",8,3,true,PRICE_CLOSE,false,1,shift);
  }
//+------------------------------------------------------------------+
//|                            FUNCTION                              |
//+------------------------------------------------------------------+
int CheckOpenPosition(int shift=0)
  {
   int result=0;
   if(upSignal(shift+2)==EMPTY_VALUE && upSignal(shift+1)!=EMPTY_VALUE)
      result=1;
   if(downSignal(shift+2)==EMPTY_VALUE && downSignal(shift+1)!=EMPTY_VALUE)
      result=2;
   return result;
  }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(IsNewCandle())
     {
      if(OrdersTotal()<1)
        {
         if(CheckOpenPosition() == 1)
           {
            double openPriceBuy  = Ask;
            double stoplossBuy   = NormalizeDouble(openPriceBuy - Stoploss*Point(),Digits);
            double takeProfitBuy        = NormalizeDouble(openPriceBuy + Take_profit*Point(),Digits);
            double lotSizeBuy = CalculateLotSize(Risk_Per_Trade,stoplossBuy)/100;
            if(lotSizeBuy < MarketInfo(Symbol(),MODE_MINLOT))
               lotSizeBuy        = MarketInfo(Symbol(),MODE_MINLOT);

            ticket               = OrderSend(Symbol(),OP_BUY,lotSizeBuy,openPriceBuy,slippage,stoplossBuy,takeProfitBuy,"BUY",MagicNumber);
           }
         if(CheckOpenPosition() == 2)
           {
            double openPriceSell = Bid;
            double stoplossSell      = NormalizeDouble(openPriceSell + Stoploss*Point(),Digits);
            double takeProfitSell       = NormalizeDouble(openPriceSell - Take_profit*Point(),Digits);
            double lotSizeSell = CalculateLotSize(Risk_Per_Trade,stoplossSell)/100;
            if(lotSizeSell < MarketInfo(Symbol(),MODE_MINLOT))
               lotSizeSell       = MarketInfo(Symbol(),MODE_MINLOT);

            ticket               = OrderSend(Symbol(),OP_SELL,lotSizeSell,openPriceSell,slippage,stoplossSell,takeProfitSell,"SELL",MagicNumber);
           }
        }
     }
  }


//+------------------------------------------------------------------+
